// ------------- READS51 generated header -------------- 
// module  : C:\Rigel\Reads51\Rita\RitaPorts\App.c
// created : 16:25:42, Monday, July 18, 2001
// ----------------------------------------------------- 

#include <sfr51.h>

// prototypes
#include <NetApi51.h>
#include <xSio51.h>

#define RITAPORT 0x2000

#define TRUE  1
#define FALSE 0

extern int RX_BUFFER, IPIN_BUFFER;
// -----------------------------------------------------
// string functions
int strlen(char *sz){
int n;
 n=0;
 while(sz[n]) n++;
 return(n);
}

void strcat(char *sz1, char *sz2){
int n1, n2;
 n1=strlen(sz1);
 n2=0;
 while(sz2[n2])
  {
   sz1[n1]=sz2[n2];
   n1++;
   n2++;
   }
 sz1[n1]=0;
}

int GetHexVal(char *sz, *n){
char c;
int k, nDigit, nResult;

 nResult=0;
 for(k=0; k<strlen(sz); k++)
  {
   c=sz[k]|0x20;
   if( (c>='0') && (c<='9') ) nDigit=c-'0';
    else if( (c>='a') && (c<='f') ) nDigit=c-'a'+10;
     else return(FALSE);
   nResult=nResult*16+nDigit;
   }
 *n=nResult;
 return(TRUE);
}

// -----------------------------------------------------
// command service routines
void CmdMenu(void){
char sz[256], szOut[256];

// serial out
 cputs("\ncommands\n");
 cputs("-------------------------\n");
 cputs("P1      : view P1 bits\n");
 cputs("P1=XX   : set P1=XX\n");
 cputs("P3      : view P3 bits (P3.5 to P3.2)\n");
 cputs("P3=XX   : set P3=XX\n");
 cputs("default : this menu\n");
 cputs("\nenter command...\n\n");

// net out
 csprintf(szOut, "\ncommands\n");
 csprintf(sz, "-------------------------\n");
 strcat(szOut, sz);
 csprintf(sz, "P1      : view P1 bits\n");
 strcat(szOut, sz);
 csprintf(sz, "P3      : view P3 bits (P3.5 to P3.2)\n");
 strcat(szOut, sz);
 csprintf(sz, "P1=XX   : set P1=XX\n");
 strcat(szOut, sz);
 csprintf(sz, "P3=XX   : set P3=XX\n");
 strcat(szOut, sz);
 csprintf(sz, "default : this menu\n");
 strcat(szOut, sz);
 csprintf(sz, "\nenter command...\n\n");
 strcat(szOut, sz);

 NetSendUdpMsg(szOut, strlen(szOut));
}
// -----------------------------------------------------
void CmdPort(char *szVal, int nPort){
char c, sz[256], szOut[256];
int  nDigit, nVal;

 if(!szVal[0])
  {
   // serial out
   if(nPort==1) csprintf(0, "P1       : %x\n", P1&0xFF);
    else csprintf(0, "P3       : %x\n", (P3>>2)&0x0F);

   // net out
   if(nPort==1) csprintf(szOut, "P1       : %x\n", P1&0xFF);
    else csprintf(szOut, "P3       : %x\n", (P3>>2)&0x0F);

   NetSendUdpMsg(szOut, strlen(szOut));
   }
  else
   {
    if(strlen(szVal==1) || strlen(szVal)==2)
     {
      if(GetHexVal(szVal, &nVal))
       {
        if(nPort==1) P1=nVal&0xFF;
         else
          {
           P3&=0xC3;
           P3|=(nVal&0x0F)<<2;
           }

        // serial out
        if(nPort==1) csprintf(0, "OK... P1 = %x\n", P1&0xFF);
         else csprintf(0, "OK... P3 = %x\n", (P3>>2)&0x0F);

        // net out
        if(nPort==1) csprintf(szOut, "OK... P1 = %x\n", P1&0xFF);
         else csprintf(szOut, "OK... P3 = %x\n", (P3>>2)&0x0F);

        NetSendUdpMsg(szOut, strlen(szOut));
        return;
        }
      }
    // serial out
    csprintf(0, "bad value (%v)\n", szVal);
    // net out
    csprintf(szOut, "bad value (%v)\n", szVal);
    NetSendUdpMsg(szOut, strlen(szOut));
    }
}
// -----------------------------------------------------

// -----------------------------------------------------
// commands 
// P1       : show P1 bits
// P1=XX    : set P1 to XX
// P3       : show P3 bits (P3.5 to P3.2)
// P3=XX    : set P3 to XX
// other    : show command list

void ProcessCommand(char *szCmd){
char c, szOut[256];
int  n, nPos;
char szVar[64], szVal[8];
int  bEqu, bErr, bSpc, bDone;

 bEqu=FALSE;
 bErr=FALSE;
 bSpc=FALSE;
 bDone=FALSE;
 szVar[0]=0;
 szVal[0]=0;
 n=0;
 nPos=0;
 do
  {
   c=szCmd[n];
   switch(c)
    {
     case  0   : if(!bEqu) szVar[nPos]=0;
                  else szVal[nPos]=0;
                 bDone=TRUE;
                 break;

     case '='  : if(bEqu)
                  {
                   bErr=TRUE;
                   bDone=TRUE;
                   }
                  else
                   {
                    bSpc=FALSE;
                    szVar[nPos]=0;
                    nPos=0;
                    bEqu=TRUE;
                    }
                 break;

     case ' '  : 
     case '\t' : if(nPos) bSpc=TRUE;
                 break;

     default   : if(bSpc)
                  {
                   bErr=TRUE;
                   if(bEqu) szVal[nPos]=0;
                    else szVar[nPos]=0;
                   bDone=TRUE;
                   }
                  else
                   {
                    if(!bEqu) szVar[nPos++]=c;
                     else szVal[nPos++]=c;
                    }
                 break;
     }
   n++;
   } while(!bDone);

 if(bEqu && !nPos) bErr=TRUE;    // equal sign present but szVal is empty

 if(bErr) CmdMenu();
  else 
   {
    c=szVar[0]|0x20; // make lower case
    if(c!='p') CmdMenu();
     else if(szVar[1]=='1') CmdPort(szVal, 1);
     else if(szVar[1]=='3') CmdPort(szVal, 3);
     else CmdMenu();
     }
}
// -----------------------------------------------------
void main(void){
int   nSize, nSrcPort, nDestPort;
char  szIn[256];
unsigned char cIP[4], cEther[6];

char *pc;

// --- initialize serial port (9600 Baud) ---
 InitSerialPort0(_9600_24_TIMER1);
 putc('\n');

 csprintf(0, "set hardware (ether) address to 05-04-03-02-01-00 ...\n");
 NetSetEtherAddress(0x0504, 0x0302, 0x0100);

 csprintf(0, "set ip address to 200.100.100.2 (C8-64-64-02)...\n");
 NetSetIPAddress(0xC864, 0x6402);

 csprintf(0, "initialize ether connection...");
 while(NetInitialize(IM_BROADCAST | IM_INDIVIDUAL)) putc('.');     // wait for hardware initialization

 csprintf(0, "   OK\n\n");

// the main polling loop
 while(1)
  {
   NetServiceMsgs(TRUE);                    // process arp and icmp messages

   nSize=NetGetUdpMsg(szIn);                // check incoming UDP messages
   if(nSize<=0) continue;

   nDestPort=NetGetUdpInDestPort();         // get destination UDP port
   if(nDestPort!=RITAPORT) continue;        // ignore UPDs to other ports

   if(!szIn[0]) continue;                   // only Rita StdAscii messages

   // the message must be a RITA UDP
   NetGetUdpInSrcEthernAddress(cEther);     // get sender's ether address
   NetGetUdpInSrcIpAddress(cIP);            // get sender's IP address (source IP)
   nSrcPort=NetGetUdpInSrcPort();           // get source UDP port
   nDestPort=NetGetUdpInDestPort();         // get destination UDP port

   szIn[nSize]=0;                           // terminate C-string
   csprintf(0, "msg      : %v\n", szIn);    // display command
/*
   csprintf(0, "\nmsg size : %d\n", nSize);

   csprintf(0, "sender's ether  : %x %x %x %x %x %x\n", cEther[0], cEther[1], cEther[2], cEther[3], cEther[4], cEther[5]);
   csprintf(0, "sender's ip     : %x %x %x %x\n", cIP[0], cIP[1], cIP[2], cIP[3]);
   csprintf(0, "SP, DP          : %x %x %x %x\n", nSrcPort, nDestPort);
*/     
   // prepare out msg
   NetSetUdpOutSrcPort(0x2000);          // our UDP port
   NetSetUdpOutDestPort(nSrcPort);       // last sender's port
   NetSetUdpOutDestEthernAddress(cEther);
   NetSetUdpOutDestIpAddress(cIP);
       
   ProcessCommand(szIn);
   } // ... the endless while loop

}


