// ------------- READS51 generated header -------------- 
// module  : C:\Rigel\Reads51\Rita\Sniff_Ether\App.c
// created : 16:25:42, Monday, July 18, 2001
// ----------------------------------------------------- 

#include <sfr51.h>

// prototypes
#include <NetApi51.h>
#include <xSio51.h>

#define RITAPORT 0x2000

#define TRUE  1
#define FALSE 0

extern int E_MSGRDY, EIN_SIZE, RX_BUFFER;
// -----------------------------------------------------
unsigned int SwapEndian(unsigned int u){
 return( ( (u&0xFF)<<8 ) | ( (u&0xFF00)>>8 ) );
}
// -----------------------------------------------------
void main(void){
int   n, nSize, *RxBuffer;
char  c;
unsigned char cIP[4], cEther[6];

// --- initialize serial port (9600 Baud) ---
 InitSerialPort0(_9600_24_TIMER1);
 putc('\n');

 cprintf("set hardware (ether) address to 05-04-03-02-01-00 ...\n");
 NetSetEtherAddress(0x0504, 0x0302, 0x0100);

 cprintf("set ip address to 200.100.100.2 (C8-64-64-02)...\n");
 NetSetIPAddress(0xC864, 0x6402);

 cprintf("initialize ether connection...");
 while(NetInitialize(IM_PROMISCUOUS)) putc('.');     // wait for hardware initialization
 cprintf("   OK\n\n");

// the main polling loop
 while(1)
  {
   NetServiceMsgs(FALSE);            // do not process arp and icmp messages

   // check incoming IP messages
   if(!E_MSGRDY) continue;
   E_MSGRDY=0;

   RxBuffer=&RX_BUFFER;

   nSize=SwapEndian(EIN_SIZE);
   cprintf("\nmessage size        : %x\n", nSize);

   cputs("\n--- ether ---\n");
   cprintf("destination address : %x %x %x\n", SwapEndian(RxBuffer[0]), SwapEndian(RxBuffer[1]), SwapEndian(RxBuffer[2]) );
   cprintf("source address      : %x %x %x\n", SwapEndian(RxBuffer[3]), SwapEndian(RxBuffer[4]), SwapEndian(RxBuffer[5]) );
   cprintf("protocol (LLC)      : %x\n", SwapEndian(RxBuffer[6]));

   cputs(  "data                :\n");

   if(nSize%2) nSize++;
   for(n=7; n<nSize/2; n++)
    {
     if(!((n-7)%16))    cprintf("\n               %x : ", n-7);
      else if(((n-7)%16)==8) cputs("- ");
     cprintf("%x ", SwapEndian(RxBuffer[n]));
     }
   cputs("\n\n");
   } // ... the endless while loop

}


